package moncheck2;


import java.awt.GridLayout;
import java.text.NumberFormat;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class CarloCo2 extends moncheck2.CarloAbstract {
	static JTextField out;
	
	public CarloCo2() {
		//Constructor stub
	}	
	
	public CarloCo2Result getInstCoResult() {
		return (new CarloCo2Result());
	}
	
	public JPanel makeGuiPanel(JPanel panel) {
		GridLayout grid = new GridLayout(2,1);
		grid.setVgap(10);
		out = new JTextField(20);
		panel.setLayout(grid);
		panel.add(new JLabel("Ich bin ein Dummy",JLabel.CENTER));
		
		panel.add(out);
		return(panel);
		
	}
	
	public void enableUI(boolean enabled) {
		System.out.println("Enabled: "+enabled);
	}
	
	public void updateDisplay(moncheck2.AbsResult displres) {
		NumberFormat nf = NumberFormat.getInstance();
		nf.setMaximumFractionDigits(0);
		nf.setMaximumIntegerDigits(20);
		out.setText(nf.format(((CarloCo2Result)displres).getDreiezahl()));
	}
	
	public CarloCo2Result reset() {		
		out.setText("reset");	
		CarloCo2Result co2res = new CarloCo2Result();
		co2res.reset();
		return(co2res);		
	}
	
	public void setParams() {
		
	}
		
	public CarloCo2Result compute() {
		CarloCo2Result res = new CarloCo2Result();
		res.setEinezahl(1F);
		res.setZweiezahl(2F);
		res.setDreiezahl(3F); 
		return(res);
	}

	public CarloCo2Result add(AbsResult r1, AbsResult r2) {
		CarloCo2Result res1 = (CarloCo2Result)r1;
		CarloCo2Result res2 = (CarloCo2Result)r2;
		CarloCo2Result ergeb = new CarloCo2Result();
		ergeb.setEinezahl(res1.getEinezahl()+res2.getEinezahl());
		ergeb.setZweiezahl(res1.getZweiezahl()+res2.getZweiezahl());
		ergeb.setDreiezahl(res1.getDreiezahl()+res2.getDreiezahl());
		return ergeb;
	}
	
	public String getHelpText() {
		return ("Ich bin ein Dummy, ich mache nichts.");
	}
	
	
}
