package moncheck2;

import java.util.List;
import java.util.concurrent.CancellationException;
import java.util.concurrent.ExecutionException;
import javax.swing.SwingWorker;

public class CarloWorker extends SwingWorker<CarloPacket, CarloPacket> {
	static int workercounter = 0;
	private Long cycles;
	private AbsResult result;
	private int id;
	CarloUI parent;
	CarloCompute comp;
	boolean machmalschluss;
	CarloData data;
	
	public CarloWorker(CarloUI father, AbsResult restype) {
		this.parent = father;
		machmalschluss = false;
		workercounter++;
		this.id=workercounter-1;
		result = restype;
		cycles = 0L;
		data = new CarloData(restype);
	}
	@Override
	public CarloPacket doInBackground() {
		CarloPacket cp = null;
		while ((!isCancelled() && !machmalschluss)) {
		cycles++;						
		result = parent.add(result, parent.compute());
		if (cycles % 100000 == 0) {
		 cp = new CarloPacket(cycles, result, id);
		 publish(cp);
		}
		}
		cp = new CarloPacket(cycles, result, id);
		return cp;
	}
	@Override
	protected void process(List<CarloPacket> packetliste) {
		CarloPacket cp = packetliste.get(packetliste.size() - 1);
		//System.out.print("Paket von Nr. "+cp.id+" angekommen mit "+cp.cycles+" Zyklen\n");
		if (this.getState()!=SwingWorker.StateValue.DONE) {
			data.setPacket(cp);
		} else {System.out.print("Letzes Paket gecancelled!\n");}		
	}
	protected void aufhoeren(boolean sollich) {
		machmalschluss = sollich;
	}
	
	
	@Override
	protected void done() {
		CarloPacket endpack = null;
		try {
		endpack = get(); 
		} 
		catch (InterruptedException ie) {System.err.print("InterruptedException\n");} 
		catch (ExecutionException ee){System.err.print("ExecutionException\n");}
		catch (CancellationException ce) {System.err.print("CancellationException\n");}
		data.setPacket(endpack);
		parent.bringFinalResults(endpack);
	}
}
